module OrdinaryDiffEqRKN

import OrdinaryDiffEqCore: alg_order, calculate_residuals!,
    initialize!, perform_step!, unwrap_alg,
    calculate_residuals, alg_extrapolates,
    OrdinaryDiffEqAlgorithm,
    OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
    OrdinaryDiffEqAdaptivePartitionedAlgorithm,
    OrdinaryDiffEqPartitionedAlgorithm,
    OrdinaryDiffEqAdaptiveAlgorithm, CompiledFloats, uses_uprev,
    alg_cache, _vec, _reshape, @cache, isfsal, full_cache,
    constvalue, _unwrap_val, _ode_interpolant,
    get_fsalfirstlast,
    trivial_limiter!, _ode_interpolant!, _ode_addsteps!,
    generic_solver_docstring
using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools
using DiffEqBase: @def, @tight_loop_macros
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("rkn_tableaus.jl")
include("rkn_caches.jl")
include("interp_func.jl")
include("interpolants.jl")
include("rkn_perform_step.jl")

export Nystrom4, FineRKN4, FineRKN5, Nystrom4VelocityIndependent,
    Nystrom5VelocityIndependent,
    IRKN3, IRKN4, DPRKN4, DPRKN5, DPRKN6, DPRKN6FM, DPRKN8, DPRKN12, ERKN4, ERKN5, ERKN7,
    RKN4

end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            DPRKN6ConstantCache,
            DPRKN6Cache,
        },
    }
    return dense ? "specialized 6th order interpolation" : "1st order linear"
end

alg_extrapolates(alg::IRKN3) = true
alg_extrapolates(alg::IRKN4) = true

alg_order(alg::IRKN3) = 3
alg_order(alg::Nystrom4) = 4
alg_order(alg::FineRKN4) = 4
alg_order(alg::FineRKN5) = 5
alg_order(alg::Nystrom4VelocityIndependent) = 4
alg_order(alg::IRKN4) = 4
alg_order(alg::Nystrom5VelocityIndependent) = 5
alg_order(alg::DPRKN4) = 4
alg_order(alg::DPRKN5) = 5
alg_order(alg::DPRKN6) = 6
alg_order(alg::DPRKN6FM) = 6
alg_order(alg::DPRKN8) = 8
alg_order(alg::DPRKN12) = 12
alg_order(alg::ERKN4) = 4
alg_order(alg::ERKN5) = 5
alg_order(alg::ERKN7) = 7
alg_order(alg::RKN4) = 4

abstract type NystromMutableCache <: OrdinaryDiffEqMutableCache end
get_fsalfirstlast(cache::NystromMutableCache, u) = (cache.fsalfirst, cache.k)

@cache struct Nystrom4Cache{uType, rateType, reducedRateType} <: NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k₂::reducedRateType
    k₃::reducedRateType
    k₄::reducedRateType
    k::rateType
    tmp::uType
end

# struct Nystrom4ConstantCache <: NystromConstantCache end

function alg_cache(
        alg::Nystrom4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    k₁ = zero(rate_prototype)
    k₂ = zero(reduced_rate_prototype)
    k₃ = zero(reduced_rate_prototype)
    k₄ = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    return Nystrom4Cache(u, uprev, k₁, k₂, k₃, k₄, k, tmp)
end

struct Nystrom4ConstantCache <: NystromConstantCache end

function alg_cache(
        alg::Nystrom4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Nystrom4ConstantCache()
end

# alg_cache(alg::Nystrom4,u,rate_prototype,::Type{uEltypeNoUnits},::Type{uBottomEltypeNoUnits},::Type{tTypeNoUnits},uprev,uprev2,f,t,dt,reltol,p,calck,::Val{false}) where {uEltypeNoUnits,uBottomEltypeNoUnits,tTypeNoUnits} = Nystrom4ConstantCache(constvalue(uBottomEltypeNoUnits),constvalue(tTypeNoUnits))

@cache struct FineRKN4Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::FineRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = FineRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return FineRKN4Cache(u, uprev, k1, k2, k3, k4, k5, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::FineRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return FineRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct FineRKN5Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k7::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::FineRKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = FineRKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k7 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return FineRKN5Cache(u, uprev, k1, k2, k3, k4, k5, k6, k7, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::FineRKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return FineRKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Nystrom4VelocityIndependentCache{uType, rateType, reducedRateType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k₂::reducedRateType
    k₃::reducedRateType
    k::rateType
    tmp::uType
end

function alg_cache(
        alg::Nystrom4VelocityIndependent, u, rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    k₁ = zero(rate_prototype)
    k₂ = zero(reduced_rate_prototype)
    k₃ = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    return Nystrom4VelocityIndependentCache(u, uprev, k₁, k₂, k₃, k, tmp)
end

struct Nystrom4VelocityIndependentConstantCache <: NystromConstantCache end

function alg_cache(
        alg::Nystrom4VelocityIndependent, u, rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Nystrom4VelocityIndependentConstantCache()
end

@cache struct IRKN3Cache{uType, rateType, TabType} <: NystromMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    fsalfirst::rateType
    k₂::rateType
    k::rateType
    tmp::uType
    tmp2::rateType
    onestep_cache::Nystrom4VelocityIndependentCache
    tab::TabType
end

function alg_cache(
        alg::IRKN3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k₁ = zero(rate_prototype)
    k₂ = zero(rate_prototype)
    k₃ = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    tab = IRKN3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return IRKN3Cache(
        u, uprev, uprev2, k₁, k₂, k, tmp, k₃,
        Nystrom4VelocityIndependentCache(u, uprev, k₁, k₂.x[2], k₃.x[2], k, tmp),
        tab
    )
end

function alg_cache(
        alg::IRKN3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return IRKN3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct IRKN4Cache{uType, rateType, TabType} <: NystromMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    fsalfirst::rateType
    k₂::rateType
    k₃::rateType
    k::rateType
    tmp::uType
    tmp2::rateType
    onestep_cache::Nystrom4VelocityIndependentCache
    tab::TabType
end

function alg_cache(
        alg::IRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k₁ = zero(rate_prototype)
    k₂ = zero(rate_prototype)
    k₃ = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    tmp2 = zero(rate_prototype)
    tab = IRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return IRKN4Cache(
        u, uprev, uprev2, k₁, k₂, k₃, k, tmp, tmp2,
        Nystrom4VelocityIndependentCache(u, uprev, k₁, k₂.x[2], k₃.x[2], k, tmp),
        tab
    )
end

function alg_cache(
        alg::IRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return IRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Nystrom5VelocityIndependentCache{uType, rateType, reducedRateType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k₂::reducedRateType
    k₃::reducedRateType
    k₄::reducedRateType
    k::rateType
    tmp::uType
    tab::TabType
end

function alg_cache(
        alg::Nystrom5VelocityIndependent, u, rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    k₁ = zero(rate_prototype)
    k₂ = zero(reduced_rate_prototype)
    k₃ = zero(reduced_rate_prototype)
    k₄ = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    tab = Nystrom5VelocityIndependentConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return Nystrom5VelocityIndependentCache(u, uprev, k₁, k₂, k₃, k₄, k, tmp, tab)
end

function alg_cache(
        alg::Nystrom5VelocityIndependent, u, rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Nystrom5VelocityIndependentConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
end

struct DPRKN4Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN4Cache(u, uprev, k1, k2, k3, k4, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::DPRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct DPRKN5Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN5Cache(u, uprev, k1, k2, k3, k4, k5, k6, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::DPRKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct DPRKN6Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN6Cache(u, uprev, k1, k2, k3, k4, k5, k6, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::DPRKN6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct DPRKN6FMCache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN6FM, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN6FMConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN6FMCache(u, uprev, k1, k2, k3, k4, k5, k6, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::DPRKN6FM, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN6FMConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct DPRKN8Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k7::reducedRateType
    k8::reducedRateType
    k9::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k7 = zero(reduced_rate_prototype)
    k8 = zero(reduced_rate_prototype)
    k9 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN8Cache(u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::DPRKN8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct DPRKN12Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k7::reducedRateType
    k8::reducedRateType
    k9::reducedRateType
    k10::reducedRateType
    k11::reducedRateType
    k12::reducedRateType
    k13::reducedRateType
    k14::reducedRateType
    k15::reducedRateType
    k16::reducedRateType
    k17::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::DPRKN12, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = DPRKN12ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k7 = zero(reduced_rate_prototype)
    k8 = zero(reduced_rate_prototype)
    k9 = zero(reduced_rate_prototype)
    k10 = zero(reduced_rate_prototype)
    k11 = zero(reduced_rate_prototype)
    k12 = zero(reduced_rate_prototype)
    k13 = zero(reduced_rate_prototype)
    k14 = zero(reduced_rate_prototype)
    k15 = zero(reduced_rate_prototype)
    k16 = zero(reduced_rate_prototype)
    k17 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return DPRKN12Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15,
        k16, k17, k, utilde, tmp, atmp, tab
    )
end

function alg_cache(
        alg::DPRKN12, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DPRKN12ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct ERKN4Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::ERKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = ERKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return ERKN4Cache(u, uprev, k1, k2, k3, k4, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::ERKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return ERKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct ERKN5Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::ERKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = ERKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return ERKN5Cache(u, uprev, k1, k2, k3, k4, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::ERKN5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return ERKN5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct ERKN7Cache{uType, rateType, reducedRateType, uNoUnitsType, TabType} <:
    NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::reducedRateType
    k3::reducedRateType
    k4::reducedRateType
    k5::reducedRateType
    k6::reducedRateType
    k7::reducedRateType
    k::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    tab::TabType
end

function alg_cache(
        alg::ERKN7, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    tab = ERKN7ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(reduced_rate_prototype)
    k3 = zero(reduced_rate_prototype)
    k4 = zero(reduced_rate_prototype)
    k5 = zero(reduced_rate_prototype)
    k6 = zero(reduced_rate_prototype)
    k7 = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    return ERKN7Cache(u, uprev, k1, k2, k3, k4, k5, k6, k7, k, utilde, tmp, atmp, tab)
end

function alg_cache(
        alg::ERKN7, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return ERKN7ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct RKN4Cache{uType, rateType, reducedRateType} <: NystromMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k₂::reducedRateType
    k₃::reducedRateType
    k::rateType
    tmp::uType
end

function alg_cache(
        alg::RKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    reduced_rate_prototype = rate_prototype.x[2]
    k₁ = zero(rate_prototype)
    k₂ = zero(reduced_rate_prototype)
    k₃ = zero(reduced_rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    return RKN4Cache(u, uprev, k₁, k₂, k₃, k, tmp)
end

struct RKN4ConstantCache <: NystromConstantCache end

function alg_cache(
        alg::RKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RKN4ConstantCache()
end

@def dprkn6unpack begin
    if cache isa OrdinaryDiffEqMutableCache
        (; r14, r13, r12, r11, r10, r34, r33, r32, r31, r44, r43, r42, r41, r54, r53, r52, r51, r64, r63, r62, r61, rp14, rp13, rp12, rp11, rp10, rp34, rp33, rp32, rp31, rp44, rp43, rp42, rp41, rp54, rp53, rp52, rp51, rp64, rp63, rp62, rp61) = cache.tab
    else
        (; r14, r13, r12, r11, r10, r34, r33, r32, r31, r44, r43, r42, r41, r54, r53, r52, r51, r64, r63, r62, r61, rp14, rp13, rp12, rp11, rp10, rp34, rp33, rp32, rp31, rp44, rp43, rp42, rp41, rp54, rp53, rp52, rp51, rp64, rp63, rp62, rp61) = cache
    end
end

@def dprkn6pre0 begin
    @dprkn6unpack
    b1Θ = @evalpoly(Θ, r10, r11, r12, r13, r14)
    b3Θ = Θ * @evalpoly(Θ, r31, r32, r33, r34)
    b4Θ = Θ * @evalpoly(Θ, r41, r42, r43, r44)
    b5Θ = Θ * @evalpoly(Θ, r51, r52, r53, r54)
    b6Θ = Θ * @evalpoly(Θ, r61, r62, r63, r64)

    bp1Θ = @evalpoly(Θ, rp10, rp11, rp12, rp13, rp14)
    bp3Θ = Θ * @evalpoly(Θ, rp31, rp32, rp33, rp34)
    bp4Θ = Θ * @evalpoly(Θ, rp41, rp42, rp43, rp44)
    bp5Θ = Θ * @evalpoly(Θ, rp51, rp52, rp53, rp54)
    bp6Θ = Θ * @evalpoly(Θ, rp61, rp62, rp63, rp64)

    kk1, kk2, kk3 = k
    k1, k2 = kk1.x
    k3, k4 = kk2.x
    k5, k6 = kk3.x

    duprev, uprev = y₀.x
    dtsq = dt^2
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{DPRKN6ConstantCache, DPRKN6Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    @dprkn6pre0
    return ArrayPartition(
        duprev +
            dt * Θ *
            (
            bp1Θ * k1 + bp3Θ * k3 +
                bp4Θ * k4 + bp5Θ * k5 + bp6Θ * k6
        ),
        uprev +
            dt * Θ *
            (
            duprev +
                dt * Θ * (
                b1Θ * k1 + b3Θ * k3 +
                    b4Θ * k4 + b5Θ * k5 + b6Θ * k6
            )
        )
    )
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{DPRKN6ConstantCache, DPRKN6Cache}, idxs,
        T::Type{Val{0}}, differential_vars::Nothing
    )
    @dprkn6pre0
    return ArrayPartition(
        duprev[idxs] +
            dt * Θ *
            (
            bp1Θ * k1[idxs] + bp3Θ * k3[idxs] +
                bp4Θ * k4[idxs] + bp5Θ * k5[idxs] + bp6Θ * k6[idxs]
        ),
        uprev[idxs] +
            dt * Θ *
            (
            duprev[idxs] +
                dt * Θ *
                (
                b1Θ * k1[idxs] +
                    b3Θ * k3[idxs] +
                    b4Θ * k4[idxs] + b5Θ * k5[idxs] + b6Θ * k6[idxs]
            )
        )
    )
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{DPRKN6ConstantCache, DPRKN6Cache}, idxs::Number,
        T::Type{Val{0}}, differential_vars::Nothing
    )
    @dprkn6pre0
    halfsize = length(y₀) ÷ 2
    if idxs <= halfsize
        duprev[idxs] +
            dt * Θ *
            (
            bp1Θ * k1[idxs] + bp3Θ * k3[idxs] +
                bp4Θ * k4[idxs] + bp5Θ * k5[idxs] + bp6Θ * k6[idxs]
        )
    else
        idxs = idxs - halfsize
        uprev[idxs] +
            dt * Θ *
            (
            duprev[idxs] +
                dt * Θ *
                (
                b1Θ * k1[idxs] +
                    b3Θ * k3[idxs] +
                    b4Θ * k4[idxs] + b5Θ * k5[idxs] + b6Θ * k6[idxs]
            )
        )
    end
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{DPRKN6ConstantCache, DPRKN6Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    @dprkn6pre0
    @inbounds @.. broadcast = false out.x[2] = uprev +
        dt * Θ *
        (
        duprev +
            dt * Θ *
            (
            b1Θ * k1 +
                b3Θ * k3 +
                b4Θ * k4 + b5Θ * k5 + b6Θ * k6
        )
    )
    @inbounds @.. broadcast = false out.x[1] = duprev +
        dt * Θ *
        (
        bp1Θ * k1 + bp3Θ * k3 +
            bp4Θ * k4 + bp5Θ * k5 + bp6Θ * k6
    )
    #for i in eachindex(out.x[1])
    #  out.x[2][i]  = uprev[i] + dt*Θ*(duprev[i] + dt*Θ*(b1Θ*k1[i] +
    #                                                    b3Θ*k3[i] +
    #                                                    b4Θ*k4[i] + b5Θ*k5[i] + b6Θ*k6[i]))
    #  out.x[1][i] =  duprev[i] + dt*Θ*(bp1Θ*k1[i] + bp3Θ*k3[i] +
    #                                   bp4Θ*k4[i] + bp5Θ*k5[i] + bp6Θ*k6[i])
    #end
    out
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{DPRKN6ConstantCache, DPRKN6Cache}, idxs,
        T::Type{Val{0}}, differential_vars::Nothing
    )
    @dprkn6pre0
    halfsize = length(y₀) ÷ 2
    isfirsthalf = idxs .<= halfsize
    secondhalf = idxs .> halfsize
    firstidxs = idxs[isfirsthalf]
    secondidxs_shifted = idxs[secondhalf]
    secondidxs = secondidxs_shifted .- halfsize

    @views @.. broadcast = false out[secondhalf] = uprev[secondidxs] +
        dt * Θ *
        (
        duprev[secondidxs] +
            dt * Θ *
            (
            b1Θ * k1[secondidxs] +
                b3Θ * k3[secondidxs] +
                b4Θ * k4[secondidxs] +
                b5Θ * k5[secondidxs] +
                b6Θ * k6[secondidxs]
        )
    )
    @views @.. broadcast = false out[isfirsthalf] = duprev[firstidxs] +
        dt * Θ *
        (
        bp1Θ * k1[firstidxs] +
            bp3Θ * k3[firstidxs] +
            bp4Θ * k4[firstidxs] +
            bp5Θ * k5[firstidxs] +
            bp6Θ * k6[firstidxs]
    )
    out
end

using OrdinaryDiffEqRKN, Test, RecursiveArrayTools, DiffEqDevTools, Statistics

u0 = fill(0.0, 2)
v0 = ones(2)
function f1_harmonic(dv, v, u, p, t)
    return dv .= -u
end
function f2_harmonic(du, v, u, p, t)
    return du .= v
end
function harmonic_analytic(y0, p, x)
    v0, u0 = y0.x
    return ArrayPartition(-u0 * sin(x) + v0 * cos(x), u0 * cos(x) + v0 * sin(x))
end
ff_harmonic = DynamicalODEFunction(f1_harmonic, f2_harmonic; analytic = harmonic_analytic)
prob = DynamicalODEProblem(ff_harmonic, v0, u0, (0.0, 5.0))

# Methods need BigFloat to test convergence rate
dts = big"1.0" ./ big"2.0" .^ (5:-1:1)
prob_big = DynamicalODEProblem(
    ff_harmonic, [big"1.0", big"1.0"],
    [big"0.0", big"0.0"], (big"0.", big"70.")
)
sim = test_convergence(dts, prob_big, DPRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN6(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 6 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN6FM(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN8(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 8 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN12(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 12 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN7(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 7 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Float64 convergence tests for DPRKN methods
# These tests ensure the CompiledFloats coefficients match the rational coefficients
# (Regression test for https://github.com/SciML/OrdinaryDiffEq.jl/issues/1938)
@testset "Float64 DPRKN convergence" begin
    # Use longer integration time to keep errors above machine precision
    prob_f64 = DynamicalODEProblem(ff_harmonic, ones(2), fill(0.0, 2), (0.0, 20.0))
    dts_f64 = 1.0 ./ 2.0 .^ (2:5)

    sim = test_convergence(dts_f64, prob_f64, DPRKN4())
    @test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1

    sim = test_convergence(dts_f64, prob_f64, DPRKN5())
    @test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1

    sim = test_convergence(dts_f64, prob_f64, DPRKN6())
    @test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1

    sim = test_convergence(dts_f64, prob_f64, DPRKN6FM())
    @test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1

    # DPRKN8 needs larger timesteps and longer integration to avoid hitting machine precision
    prob_f64_long = DynamicalODEProblem(ff_harmonic, ones(2), fill(0.0, 2), (0.0, 50.0))
    dts_f64_large = [1.0, 0.5, 0.25, 0.125]
    sim = test_convergence(dts_f64_large, prob_f64_long, DPRKN8())
    @test sim.𝒪est[:l2] ≈ 8 rtol = 1.0e-1

    # DPRKN12 is too accurate for Float64 convergence testing (hits machine precision
    # even at dt=1.0), so we only test it with BigFloat (see tests above)
end

sol = solve(prob, Nystrom4(), dt = 1 / 1000)

# Nyström method
dts = 1 .// 2 .^ (9:-1:6)
sim = test_convergence(dts, prob, RKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, Nystrom4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, Nystrom4VelocityIndependent(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, IRKN3(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 3 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 3 rtol = 1.0e-1
sim = test_convergence(dts, prob, IRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
dts = 1.0 ./ 2.0 .^ (5:-1:0)
sim = test_convergence(dts, prob, Nystrom5VelocityIndependent(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Adaptive methods regression test
sol = solve(prob, FineRKN4())
@test length(sol.u) < 16
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FineRKN5())
@test length(sol.u) < 14
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN4())
@test length(sol.u) < 25
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN5())
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN6())
@test length(sol.u) < 20
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN6FM())
@test length(sol.u) < 25
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN8())
@test length(sol.u) < 13
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN12())
@test length(sol.u) < 10
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN4(), reltol = 1.0e-8)
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN5(), reltol = 1.0e-8)
@test length(sol.u) < 34
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN7(), reltol = 1.0e-8)
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)

u0 = 0.0
v0 = 1.0
function f1_harmonic_nip(v, u, p, t)
    return -u
end
function f2_harmonic_nip(v, u, p, t)
    return v
end

ff_harmonic_nip = DynamicalODEFunction(
    f1_harmonic_nip, f2_harmonic_nip;
    analytic = harmonic_analytic
)
prob = DynamicalODEProblem(ff_harmonic_nip, v0, u0, (0.0, 5.0))

dts = 1 .// 2 .^ (9:-1:6)
sim = test_convergence(dts, prob, RKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, Nystrom4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, Nystrom4VelocityIndependent(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
@test_broken sim = test_convergence(dts, prob, IRKN3(), dense_errors = true)
@test_broken sim.𝒪est[:l2] ≈ 3 rtol = 1.0e-1
@test_broken sim.𝒪est[:L2] ≈ 3 rtol = 1.0e-1
@test_broken sim = test_convergence(dts, prob, IRKN4(), dense_errors = true)
#@test_broken sim.𝒪est[:l2] ≈ 4 rtol = 1e-1
#@test_broken sim.𝒪est[:L2] ≈ 4 rtol = 1e-1
dts = 1.0 ./ 2.0 .^ (5:-1:0)
sim = test_convergence(dts, prob, Nystrom5VelocityIndependent(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Methods need BigFloat to test convergence rate
dts = big"1.0" ./ big"2.0" .^ (5:-1:1)
prob_big = DynamicalODEProblem(
    ff_harmonic_nip, big"1.0", big"0.0",
    (big"0.", big"70.")
)
sim = test_convergence(dts, prob_big, DPRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN6(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 6 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN6FM(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 6 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN8(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 8 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, DPRKN12(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 12 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob_big, ERKN7(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 7 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Adaptive methods regression test
sol = solve(prob, FineRKN4())
@test length(sol.u) < 16
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FineRKN5())
@test length(sol.u) < 14
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN4())
@test length(sol.u) < 25
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN5())
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN6())
@test length(sol.u) < 20
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN6FM())
@test length(sol.u) < 25
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN8())
@test length(sol.u) < 13
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, DPRKN12())
@test length(sol.u) < 10
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN4(), reltol = 1.0e-8)
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN5(), reltol = 1.0e-8)
@test length(sol.u) < 34
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, ERKN7(), reltol = 1.0e-8)
@test length(sol.u) < 38
@test SciMLBase.successful_retcode(sol)

# Testing generalized Runge-Kutte-Nyström methods on velocity dependent ODEs with the damped oscillator
println("Out of Place")

# Damped oscillator
prob = ODEProblem(
    DynamicalODEFunction{false}(
        (du, u, p, t) -> -u - 0.5 * du,
        (du, u, p, t) -> du,
        analytic = (du0_u0, p, t) -> ArrayPartition(
            [
                exp(-t / 4) / 15 * (
                    15 * du0_u0[1] * cos(sqrt(15) * t / 4) -
                        sqrt(15) * (du0_u0[1] + 4 * du0_u0[2]) * sin(sqrt(15) * t / 4)
                ),
            ], # du
            [
                exp(-t / 4) / 15 * (
                    15 * du0_u0[2] * cos(sqrt(15) * t / 4) +
                        sqrt(15) * (4 * du0_u0[1] + du0_u0[2]) * sin(sqrt(15) * t / 4)
                ),
            ]
        )
    ),
    ArrayPartition([0.0], [1.0]), # du0, u0
    (0.0, 10.0), # tspan
    SciMLBase.NullParameters(), # p
    SecondOrderODEProblem{false}()
)

dts = 1.0 ./ 2.0 .^ (5:-1:0)
sim = test_convergence(dts, prob, Nystrom4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Adaptive methods regression test

sol = solve(prob, FineRKN4())
@test length(sol.u) < 28
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FineRKN5())
@test length(sol.u) < 20
@test SciMLBase.successful_retcode(sol)

println("In Place")
# Damped oscillator
prob = ODEProblem(
    DynamicalODEFunction{true}(
        (d_du, du, u, p, t) -> @.(d_du = -u - 0.5 * du),
        (d_u, du, u, p, t) -> d_u .= du,
        analytic = (du0_u0, p, t) -> ArrayPartition(
            [
                exp(-t / 4) / 15 * (
                    15 * du0_u0[1] * cos(sqrt(15) * t / 4) -
                        sqrt(15) * (du0_u0[1] + 4 * du0_u0[2]) * sin(sqrt(15) * t / 4)
                ),
            ], # du
            [
                exp(-t / 4) / 15 * (
                    15 * du0_u0[2] * cos(sqrt(15) * t / 4) +
                        sqrt(15) * (4 * du0_u0[1] + du0_u0[2]) * sin(sqrt(15) * t / 4)
                ),
            ]
        )
    ),
    ArrayPartition([0.0], [1.0]), # du0, u0
    (0.0, 10.0), # tspan
    SciMLBase.NullParameters(), # p
    SecondOrderODEProblem{false}()
)

dts = 1.0 ./ 2.0 .^ (5:-1:0)
sim = test_convergence(dts, prob, Nystrom4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN4(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 4 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1
sim = test_convergence(dts, prob, FineRKN5(), dense_errors = true)
@test sim.𝒪est[:l2] ≈ 5 rtol = 1.0e-1
@test sim.𝒪est[:L2] ≈ 4 rtol = 1.0e-1

# Adaptive methods regression test
sol = solve(prob, FineRKN4())
@test length(sol.u) < 28
@test SciMLBase.successful_retcode(sol)
sol = solve(prob, FineRKN5())
@test length(sol.u) < 20
@test SciMLBase.successful_retcode(sol)

# Compare in-place and out-of-place versions
function damped_oscillator(du, u, p, t)
    return -u - 0.5 * du
end
function damped_oscillator!(ddu, du, u, p, t)
    @. ddu = -u - 0.5 * du
    return nothing
end
@testset "in-place vs. out-of-place" begin
    ode_i = SecondOrderODEProblem(
        damped_oscillator!,
        [0.0], [1.0],
        (0.0, 10.0)
    )
    ode_o = SecondOrderODEProblem(
        damped_oscillator,
        [0.0], [1.0],
        (0.0, 10.0)
    )

    @testset "Nystrom4" begin
        alg = Nystrom4()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, dt = dt)
        sol_o = solve(ode_o, alg, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 4 * sol_i.stats.naccept) < 4
    end

    @testset "RKN4" begin
        alg = RKN4()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, dt = dt)
        sol_o = solve(ode_o, alg, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 2 * sol_i.stats.naccept) < 4
    end
    @testset "FineRKN4" begin
        alg = FineRKN4()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 5 * sol_i.stats.naccept) < 4
        # adaptive time step — IIP broadcast vs OOP array ops produce
        # per-step FP rounding differences that cascade through the step
        # controller; on Julia 1.10 the LLVM codegen amplifies this enough
        # to change the accepted step sequence.
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "FineRKN5" begin
        alg = FineRKN5()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 7 * sol_i.stats.naccept) < 4
        # adaptive time step - IIP vs OOP may diverge version-dependently
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        @test_skip sol_i.t ≈ sol_o.t
        @test_skip sol_i.u ≈ sol_o.u
    end

    @testset "DPRKN4" begin
        alg = DPRKN4()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 4 * sol_i.stats.naccept) < 4
        # adaptive time step — see FineRKN4 comment on Julia 1.10 FP divergence
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "DPRKN5" begin
        alg = DPRKN5()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 6 * sol_i.stats.naccept) < 4
        # adaptive time step — see FineRKN4 comment on Julia 1.10 FP divergence
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "DPRKN6" begin
        alg = DPRKN6()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 6 * sol_i.stats.naccept) < 4
        # adaptive time step — see FineRKN4 comment on Julia 1.10 FP divergence
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "DPRKN6FM" begin
        alg = DPRKN6FM()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 6 * sol_i.stats.naccept) < 4
        # adaptive time step
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "DPRKN8" begin
        alg = DPRKN8()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 9 * sol_i.stats.naccept) < 4
        # adaptive time step
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        if VERSION >= v"1.11"
            @test sol_i.t ≈ sol_o.t
            @test sol_i.u ≈ sol_o.u
        else
            @test_broken sol_i.t ≈ sol_o.t
            @test_broken sol_i.u ≈ sol_o.u
        end
    end

    @testset "DPRKN12" begin
        alg = DPRKN12()
        dt = 0.5
        # fixed time step
        sol_i = solve(ode_i, alg, adaptive = false, dt = dt)
        sol_o = solve(ode_o, alg, adaptive = false, dt = dt)
        @test sol_i.t ≈ sol_o.t
        @test sol_i.u ≈ sol_o.u
        @test sol_i.stats.nf == sol_o.stats.nf
        @test sol_i.stats.nf2 == sol_o.stats.nf2
        @test sol_i.stats.naccept == sol_o.stats.naccept
        @test 19 <= sol_i.stats.naccept <= 21
        @test abs(sol_i.stats.nf - 17 * sol_i.stats.naccept) < 4
        # adaptive time step
        sol_i = solve(ode_i, alg)
        sol_o = solve(ode_o, alg)
        @test_broken sol_i.t ≈ sol_o.t
        @test_broken sol_i.u ≈ sol_o.u
    end
end

@doc generic_solver_docstring(
    "Method of order three, which minimizes the amount of evaluated functions in each step. Fixed time steps only.
Second order ODE should not depend on the first derivative.",
    "IRKN3",
    "Improved Runge-Kutta-Nyström method",
    "@article{rabiei2012numerical,
    title={Numerical Solution of Second-Order Ordinary Differential Equations by Improved Runge-Kutta Nystrom Method},
    author={Rabiei, Faranak and Ismail, Fudziah and Norazak, S and Emadi, Saeid},
    publisher={Citeseer}}", "", ""
)
struct IRKN3 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "4th order explicit Runge-Kutta-Nyström method. Allows acceleration to depend on velocity.",
    "Nystrom4",
    "Improved Runge-Kutta-Nyström method",
    "E. Hairer, S.P. Norsett, G. Wanner, (1993) Solving Ordinary Differential Equations I.
    Nonstiff Problems. 2nd Edition. Springer Series in Computational Mathematics,
    Springer-Verlag.", "", ""
)
struct Nystrom4 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "A 4th order explicit method which can be applied directly to second order ODEs.
In particular, this method allows the acceleration equation to depend on the velocity.",
    "FineRKN4",
    "Improved Runge-Kutta-Nyström method",
    "@article{fine1987low,
    title={Low order practical {R}unge-{K}utta-{N}ystr{\"o}m methods},
    author={Fine, Jerry Michael},
    journal={Computing},
    volume={38},
    number={4},
    pages={281--297},
    year={1987},
    publisher={Springer}}", "", ""
)
struct FineRKN4 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "A 5th order explicit method which can be applied directly to second order ODEs.
In particular, this method allows the acceleration equation to depend on the velocity.",
    "FineRKN5",
    "Improved Runge-Kutta-Nyström method",
    "@article{fine1987low,
    title={Low order practical {R}unge-{K}utta-{N}ystr{\"o}m methods},
    author={Fine, Jerry Michael},
    journal={Computing},
    volume={38},
    number={4},
    pages={281--297},
    year={1987},
    publisher={Springer}}", "", ""
)
struct FineRKN5 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "A 4th order explicit method.
Used directly on second order ODEs, where the acceleration is independent from velocity
(ODE Problem is not dependent on the first derivative).",
    "Nystrom4VelocityIndependent",
    "Improved Runge-Kutta-Nyström method",
    "E. Hairer, S.P. Norsett, G. Wanner, (1993) Solving Ordinary Differential Equations I.
    Nonstiff Problems. 2nd Edition. Springer Series in Computational Mathematics,
    Springer-Verlag.", "", ""
)
struct Nystrom4VelocityIndependent <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Improves Runge-Kutta-Nyström method of order four,
    which minimizes the amount of evaluated functions in each step.
    Fixed time steps only.
    Second order ODE should not be dependent on the first derivative.
    Recommended for smooth problems with expensive functions to evaluate.",
    "IRKN4",
    "Improved Runge-Kutta-Nyström method",
    "@article{rabiei2012numerical,
    title={Numerical Solution of Second-Order Ordinary Differential Equations by Improved Runge-Kutta Nystrom Method},
    author={Rabiei, Faranak and Ismail, Fudziah and Norazak, S and Emadi, Saeid},
    publisher={Citeseer}}", "", ""
)
struct IRKN4 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "A 5th order explicit method.
Used directly on second order ODEs, where the acceleration is independent from velocity
(ODE Problem is not dependent on the first derivative).",
    "Nystrom5VelocityIndependent",
    "Improved Runge-Kutta-Nyström method",
    "E. Hairer, S.P. Norsett, G. Wanner, (1993) Solving Ordinary Differential Equations I.
    Nonstiff Problems. 2nd Edition. Springer Series in Computational Mathematics,
    Springer-Verlag.", "", ""
)
struct Nystrom5VelocityIndependent <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "4th order explicit method.
    The second order ODE should not depend on the first derivative.",
    "DPRKN4",
    "Improved Runge-Kutta-Nyström method",
    "@article{Dormand1987FamiliesOR,
    title={Families of Runge-Kutta-Nystrom Formulae},
    author={J. R. Dormand and Moawwad E. A. El-Mikkawy and P. J. Prince},
    journal={Ima Journal of Numerical Analysis},
    year={1987},
    volume={7},
    pages={235-250}}", "", ""
)
struct DPRKN4 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "5th order explicit method.
    The second order ODE should not depend on the first derivative.",
    "DPRKN5",
    "Improved Runge-Kutta-Nyström method",
    "@article{Bettis1973ARN,
    title={A Runge-Kutta Nystrom algorithm},
    author={Dale G. Bettis},
    journal={Celestial mechanics},
    year={1973},
    volume={8},
    pages={229-233},
    publisher={Springer}}", "", ""
)
struct DPRKN5 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "6th order explicit method.
The second order ODE should not depend on the first derivative. Free 6th order interpolant",
    "DPRKN6",
    "Improved Runge-Kutta-Nyström method",
    "@article{Dormand1987FamiliesOR,
    title={Families of Runge-Kutta-Nystrom Formulae},
    author={J. R. Dormand and Moawwad E. A. El-Mikkawy and P. J. Prince},
    journal={Ima Journal of Numerical Analysis},
    year={1987},
    volume={7},
    pages={235-250}}", "", ""
)
struct DPRKN6 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "6th order explicit method.
    The second order ODE should not depend on the first derivative.
    Compared to [`DPRKN6`](@ref), this method has smaller truncation error coefficients
    which leads to performance gain when only the main solution points are considered.",
    "DPRKN6FM",
    "Improved Runge-Kutta-Nyström method",
    "@article{Dormand1987FamiliesOR,
    title={Families of Runge-Kutta-Nystrom Formulae},
    author={J. R. Dormand and Moawwad E. A. El-Mikkawy and P. J. Prince},
    journal={Ima Journal of Numerical Analysis},
    year={1987},
    volume={7},
    pages={235-250}}", "", ""
)
struct DPRKN6FM <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "8th order explicit method.
    The second order ODE should not depend on the first derivative.
    Not as efficient as [`DPRKN12`](@ref) when high accuracy is needed,
    however this solver is competitive with [`DPRKN6`](@ref) at lax tolerances and,
    depending on the problem, might be a good option between performance and accuracy.",
    "DPRKN8",
    "Improved Runge-Kutta-Nyström method",
    "@article{dormand1987high,
    title={High-order embedded Runge-Kutta-Nystrom formulae},
    author={Dormand, JR and El-Mikkawy, MEA and Prince, PJ},
    journal={IMA Journal of Numerical Analysis},
    volume={7},
    number={4},
    pages={423--430},
    year={1987},
    publisher={Oxford University Press}}", "", ""
)
struct DPRKN8 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "12th order explicit method.
    The second order ODE should not depend on the first derivative.
    Most efficient when high accuracy is needed.",
    "DPRKN12",
    "Improved Runge-Kutta-Nyström method",
    "@article{dormand1987high,
    title={High-order embedded Runge-Kutta-Nystrom formulae},
    author={Dormand, JR and El-Mikkawy, MEA and Prince, PJ},
    journal={IMA Journal of Numerical Analysis},
    volume={7},
    number={4},
    pages={423--430},
    year={1987},
    publisher={Oxford University Press}}", "", ""
)
struct DPRKN12 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "Embedded 4(3) pair of explicit methods.
    Integrates the periodic properties of the harmonic oscillator exactly.
    The second order ODE should not depend on the first derivative.
    Uses adaptive step size control. This method is extra efficient on periodic problems.",
    "ERKN4",
    "Improved Runge-Kutta-Nyström method",
    "@article{demba2017embedded,
    title={An Embedded 4 (3) Pair of Explicit Trigonometrically-Fitted Runge-Kutta-Nystr{\"o}m Method for Solving Periodic Initial Value Problems},
    author={Demba, MA and Senu, N and Ismail, F},
    journal={Applied Mathematical Sciences},
    volume={11},
    number={17},
    pages={819--838},
    year={2017}}", "", ""
)
struct ERKN4 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "Embedded 5(4) pair of explicit methods.
    Integrates the periodic properties of the harmonic oscillator exactly.
    The second order ODE should not depend on the first derivative.
    Uses adaptive step size control. This method is extra efficient on periodic problems.",
    "ERKN5",
    "Improved Runge-Kutta-Nyström method",
    "@article{demba20165,
    title={A 5 (4) Embedded Pair of Explicit Trigonometrically-Fitted Runge--Kutta--Nystr{\"o}m Methods for the Numerical Solution of Oscillatory Initial Value     Problems},
    author={Demba, Musa A and Senu, Norazak and Ismail, Fudziah},
    journal={Mathematical and Computational Applications},
    volume={21},
    number={4},
    pages={46},
    year={2016},
    publisher={Multidisciplinary Digital Publishing Institute}}", "", ""
)
struct ERKN5 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "Embedded pair of explicit methods.
    Integrates the periodic properties of the harmonic oscillator exactly.
    The second order ODE should not depend on the first derivative.
    Uses adaptive step size control. This method is extra efficient on periodic problems.",
    "ERKN7",
    "Improved Runge-Kutta-Nyström method",
    "@article{SimosOnHO,
    title={On high order Runge-Kutta-Nystr{\"o}m pairs},
    author={Theodore E. Simos and Ch. Tsitouras},
    journal={J. Comput. Appl. Math.},
    volume={400},
    pages={113753}}", "", ""
)
struct ERKN7 <: OrdinaryDiffEqAdaptivePartitionedAlgorithm end

@doc generic_solver_docstring(
    "3 stage fourth order method to solve second order linear inhomogeneous IVPs.
Does not include an adaptive method. Solves for for d-dimensional differential systems of second order linear inhomogeneous equations.

!!! warning
This method is only fourth order for these systems, the method is second order otherwise!",
    "RKN4",
    "Improved Runge-Kutta-Nyström method",
    "@article{MONTIJANO2024115533,
    title = {Explicit Runge–Kutta–Nyström methods for the numerical solution of second order linear inhomogeneous IVPs},
    author = {J.I. Montijano and L. Rández and M. Calvo},
    journal = {Journal of Computational and Applied Mathematics},
    volume = {438},
    pages = {115533},
    year = {2024},}", "", ""
)
struct RKN4 <: OrdinaryDiffEqAlgorithm end

## y'' = f(t, y, y')
## y(t₀) = y₀; y'(t₀) = y'₀
## kᵢ' = f(t₀+cᵢh, y₀+cᵢhy'₀+h²∑āᵢⱼk'ⱼ, y'₀+h∑aᵢⱼk'ⱼ)
## y₁ = y₀ + hy'₀ + h²∑b̄ᵢk'ᵢ
## y'₁ = y'₀ + h∑bᵢk'ᵢ

const NystromCCDefaultInitialization = Union{
    Nystrom4ConstantCache, FineRKN4ConstantCache,
    FineRKN5ConstantCache,
    Nystrom4VelocityIndependentConstantCache,
    Nystrom5VelocityIndependentConstantCache,
    IRKN3ConstantCache, IRKN4ConstantCache,
    DPRKN4ConstantCache, DPRKN5ConstantCache,
    DPRKN6FMConstantCache, DPRKN8ConstantCache,
    DPRKN12ConstantCache, ERKN4ConstantCache,
    ERKN5ConstantCache, ERKN7ConstantCache, RKN4ConstantCache,
}

function initialize!(integrator, cache::NystromCCDefaultInitialization)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    duprev, uprev = integrator.uprev.x
    kdu = integrator.f.f1(duprev, uprev, integrator.p, integrator.t)
    ku = integrator.f.f2(duprev, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    return integrator.fsalfirst = ArrayPartition((kdu, ku))
end

const NystromDefaultInitialization = Union{
    Nystrom4Cache, FineRKN4Cache, FineRKN5Cache,
    Nystrom4VelocityIndependentCache,
    Nystrom5VelocityIndependentCache,
    IRKN3Cache, IRKN4Cache,
    DPRKN4Cache, DPRKN5Cache,
    DPRKN6FMCache, DPRKN8Cache,
    DPRKN12Cache, ERKN4Cache,
    ERKN5Cache, ERKN7Cache,
}

function initialize!(integrator, cache::NystromDefaultInitialization)
    (; fsalfirst, k) = cache
    duprev, uprev = integrator.uprev.x
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f.f1(integrator.k[1].x[1], duprev, uprev, integrator.p, integrator.t)
    integrator.f.f2(integrator.k[1].x[2], duprev, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return integrator.stats.nf2 += 1
end

@muladd function perform_step!(
        integrator, cache::Nystrom4ConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    k₁ = integrator.fsalfirst.x[1]
    halfdt = dt / 2
    dtsq = dt^2
    eighth_dtsq = dtsq / 8
    half_dtsq = dtsq / 2
    ttmp = t + halfdt

    ## y₁ = y₀ + hy'₀ + h²∑b̄ᵢk'ᵢ
    ku = uprev + halfdt * duprev + eighth_dtsq * k₁
    ## y'₁ = y'₀ + h∑bᵢk'ᵢ
    kdu = duprev + halfdt * k₁

    k₂ = f.f1(kdu, ku, p, ttmp)
    ku = uprev + halfdt * duprev + eighth_dtsq * k₁
    kdu = duprev + halfdt * k₂

    k₃ = f.f1(kdu, ku, p, ttmp)
    ku = uprev + dt * duprev + half_dtsq * k₃
    kdu = duprev + dt * k₃

    k₄ = f.f1(kdu, ku, p, t + dt)
    u = uprev + (dtsq / 6) * (k₁ + k₂ + k₃) + dt * duprev
    du = duprev + (dt / 6) * (k₁ + k₄ + 2 * (k₂ + k₃))

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::Nystrom4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, fsalfirst, k₂, k₃, k₄, k) = cache
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    k₁ = integrator.fsalfirst.x[1]
    halfdt = dt / 2
    dtsq = dt^2
    eighth_dtsq = dtsq / 8
    half_dtsq = dtsq / 2
    ttmp = t + halfdt

    ## y₁ = y₀ + hy'₀ + h²∑b̄ᵢk'ᵢ
    @.. broadcast = false ku = uprev + halfdt * duprev + eighth_dtsq * k₁
    ## y'₁ = y'₀ + h∑bᵢk'ᵢ
    @.. broadcast = false kdu = duprev + halfdt * k₁

    f.f1(k₂, kdu, ku, p, ttmp)
    @.. broadcast = false ku = uprev + halfdt * duprev + eighth_dtsq * k₁
    @.. broadcast = false kdu = duprev + halfdt * k₂

    f.f1(k₃, kdu, ku, p, ttmp)
    @.. broadcast = false ku = uprev + dt * duprev + half_dtsq * k₃
    @.. broadcast = false kdu = duprev + dt * k₃

    f.f1(k₄, kdu, ku, p, t + dt)
    @.. broadcast = false u = uprev + (dtsq / 6) * (k₁ + k₂ + k₃) + dt * duprev
    @.. broadcast = false du = duprev + (dt / 6) * (k₁ + k₄ + 2 * (k₂ + k₃))

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
end

@muladd function perform_step!(
        integrator, cache::FineRKN4ConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (;
        c2, c3, c4, c5, a21, a31, a32, a41, a43, a51,
        a52, a53, a54, abar21, abar31, abar32, abar41, abar42, abar43, abar51,
        abar52, abar53, abar54, b1, b3, b4, b5, bbar1, bbar3, bbar4, bbar5, btilde1, btilde3, btilde4, btilde5, bptilde1,
        bptilde3, bptilde4, bptilde5,
    ) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c2 * duprev + dt * (a21 * k1))
    kdu = duprev + dt * (abar21 * k1)

    k2 = f.f1(kdu, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a31 * k1 + a32 * k2))
    kdu = duprev + dt * (abar31 * k1 + abar32 * k2)

    k3 = f.f1(kdu, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a41 * k1 + a43 * k3)) # a42 = 0
    kdu = duprev + dt * (abar41 * k1 + abar42 * k2 + abar43 * k3)

    k4 = f.f1(kdu, ku, p, t + dt * c4)
    ku = uprev + dt * (c5 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))
    kdu = duprev + dt * (abar51 * k1 + abar52 * k2 + abar53 * k3 + abar54 * k4)

    k5 = f.f1(kdu, ku, p, t + dt * c5)

    u = uprev + dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5)) # b2 = 0
    du = duprev + dt * (bbar1 * k1 + bbar3 * k3 + bbar4 * k4 + bbar5 * k5) # bbar2 = 0

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5) # btilde2 = 0
        duhat = dt * (bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5) # bptilde2 = 0
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::FineRKN4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k, utilde) = cache
    (;
        c2, c3, c4, c5, a21, a31, a32, a41, a43, a51,
        a52, a53, a54, abar21, abar31, abar32, abar41, abar42, abar43, abar51,
        abar52, abar53, abar54, b1, b3, b4, b5, bbar1, bbar3, bbar4, bbar5, btilde1, btilde3, btilde4, btilde5, bptilde1,
        bptilde3, bptilde4, bptilde5,
    ) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a21 * k1))
    @.. broadcast = false kdu = duprev + dt * (abar21 * k1)

    f.f1(k2, kdu, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev + dt * (c3 * duprev + dt * (a31 * k1 + a32 * k2))
    @.. broadcast = false kdu = duprev + dt * (abar31 * k1 + abar32 * k2)

    f.f1(k3, kdu, ku, p, t + dt * c3)
    @.. broadcast = false ku = uprev +
        dt * (c4 * duprev + dt * (a41 * k1 + a43 * k3)) # a42 = 0
    @.. broadcast = false kdu = duprev + dt * (abar41 * k1 + abar42 * k2 + abar43 * k3)

    f.f1(k4, kdu, ku, p, t + dt * c4)
    @.. broadcast = false ku = uprev +
        dt *
        (c5 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))
    @.. broadcast = false kdu = duprev +
        dt * (abar51 * k1 + abar52 * k2 + abar53 * k3 + abar54 * k4)

    f.f1(k5, kdu, ku, p, t + dt * c5)
    @.. broadcast = false u = uprev +
        dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5)) # b2 = 0
    @.. broadcast = false du = duprev +
        dt *
        (bbar1 * k1 + bbar3 * k3 + bbar4 * k4 + bbar5 * k5) # bbar2 = 0

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @.. broadcast = false uhat = dtsq *
            (
            btilde1 * k1 + btilde3 * k3 + btilde4 * k4 +
                btilde5 * k5
        ) # btilde2 = 0
        @.. broadcast = false duhat = dt *
            (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 +
                bptilde5 * k5
        ) # bptilde2 = 0

        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(
        integrator, cache::FineRKN5ConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c2, c3, c4, c5, c6, c7, a21, a31, a32, a41, a43, a51, a52, a53, a54, a61, a62, a63, a64, a71, a73, a74, a75, abar21, abar31, abar32, abar41, abar42, abar43, abar51, abar52, abar53, abar54, abar61, abar62, abar63, abar64, abar65, abar71, abar73, abar74, abar75, abar76, b1, b3, b4, b5, bbar1, bbar3, bbar4, bbar5, bbar6, btilde1, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c2 * duprev + dt * (a21 * k1))
    kdu = duprev + dt * (abar21 * k1)

    k2 = f.f1(kdu, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a31 * k1 + a32 * k2))
    kdu = duprev + dt * (abar31 * k1 + abar32 * k2)

    k3 = f.f1(kdu, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a41 * k1 + a43 * k3)) # a42 = 0
    kdu = duprev + dt * (abar41 * k1 + abar42 * k2 + abar43 * k3)

    k4 = f.f1(kdu, ku, p, t + dt * c4)
    ku = uprev + dt * (c5 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))
    kdu = duprev + dt * (abar51 * k1 + abar52 * k2 + abar53 * k3 + abar54 * k4)

    k5 = f.f1(kdu, ku, p, t + dt * c5)
    ku = uprev +
        dt * (c6 * duprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4)) # a65 = 0
    kdu = duprev +
        dt * (abar61 * k1 + abar62 * k2 + abar63 * k3 + abar64 * k4 + abar65 * k5)

    k6 = f.f1(kdu, ku, p, t + dt * c6)
    ku = uprev +
        dt * (
        c7 * duprev +
            dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5)
    ) # a72 = a76 = 0
    kdu = duprev +
        dt * (
        abar71 * k1 + abar73 * k3 + abar74 * k4 + abar75 * k5 +
            abar76 * k6
    ) # abar72 = 0

    k7 = f.f1(kdu, ku, p, t + dt * c7)
    u = uprev + dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5)) # no b6, b7
    du = duprev + dt * (bbar1 * k1 + bbar3 * k3 + bbar4 * k4 + bbar5 * k5 + bbar6 * k6) # no b2, b7

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5)
        duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5 +
                bptilde6 * k6 + bptilde7 * k7
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::FineRKN5Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k7, k, utilde) = cache
    (; c1, c2, c3, c4, c5, c6, c7, a21, a31, a32, a41, a43, a51, a52, a53, a54, a61, a62, a63, a64, a71, a73, a74, a75, abar21, abar31, abar32, abar41, abar42, abar43, abar51, abar52, abar53, abar54, abar61, abar62, abar63, abar64, abar65, abar71, abar73, abar74, abar75, abar76, b1, b3, b4, b5, bbar1, bbar3, bbar4, bbar5, bbar6, btilde1, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a21 * k1))
    @.. broadcast = false kdu = duprev + dt * (abar21 * k1)

    f.f1(k2, kdu, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev + dt * (c3 * duprev + dt * (a31 * k1 + a32 * k2))
    @.. broadcast = false kdu = duprev + dt * (abar31 * k1 + abar32 * k2)

    f.f1(k3, kdu, ku, p, t + dt * c3)
    @.. broadcast = false ku = uprev +
        dt * (c4 * duprev + dt * (a41 * k1 + a43 * k3)) # a42 = 0
    @.. broadcast = false kdu = duprev + dt * (abar41 * k1 + abar42 * k2 + abar43 * k3)

    f.f1(k4, kdu, ku, p, t + dt * c4)
    @.. broadcast = false ku = uprev +
        dt *
        (c5 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))
    @.. broadcast = false kdu = duprev +
        dt * (abar51 * k1 + abar52 * k2 + abar53 * k3 + abar54 * k4)

    f.f1(k5, kdu, ku, p, t + dt * c5)
    @.. broadcast = false ku = uprev +
        dt * (
        c6 * duprev +
            dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4)
    ) # a65 = 0
    @.. broadcast = false kdu = duprev +
        dt * (
        abar61 * k1 + abar62 * k2 + abar63 * k3 + abar64 * k4 +
            abar65 * k5
    )

    f.f1(k6, kdu, ku, p, t + dt * c6)
    @.. broadcast = false ku = uprev +
        dt * (
        c7 * duprev +
            dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5)
    ) # a72 = a76 = 0
    @.. broadcast = false kdu = duprev +
        dt * (
        abar71 * k1 + abar73 * k3 + abar74 * k4 +
            abar75 * k5 + abar76 * k6
    ) # abar72 = 0

    f.f1(k7, kdu, ku, p, t + dt * c7)
    @.. broadcast = false u = uprev +
        dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5))
    @.. broadcast = false du = duprev +
        dt *
        (bbar1 * k1 + bbar3 * k3 + bbar4 * k4 + bbar5 * k5 + bbar6 * k6)

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @.. broadcast = false uhat = dtsq *
            (
            btilde1 * k1 + btilde3 * k3 + btilde4 * k4 +
                btilde5 * k5
        )
        @.. broadcast = false duhat = dt *
            (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 +
                bptilde5 * k5 + bptilde6 * k6 + bptilde7 * k7
        )

        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(
        integrator, cache::Nystrom4VelocityIndependentConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    k₁ = integrator.fsalfirst.x[1]
    halfdt = dt / 2
    dtsq = dt^2
    eighth_dtsq = dtsq / 8
    half_dtsq = dtsq / 2
    ttmp = t + halfdt

    ## y₁ = y₀ + hy'₀ + h²∑b̄ᵢk'ᵢ
    ku = uprev + halfdt * duprev + eighth_dtsq * k₁

    k₂ = f.f1(duprev, ku, p, ttmp)
    ku = uprev + dt * duprev + half_dtsq * k₂

    k₃ = f.f1(duprev, ku, p, t + dt)
    u = uprev + (dtsq / 6) * (k₁ + 2 * k₂) + dt * duprev
    du = duprev + (dt / 6) * (k₁ + k₃ + 4 * k₂)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(
        integrator, cache::Nystrom4VelocityIndependentCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, fsalfirst, k₂, k₃, k) = cache
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    k₁ = integrator.fsalfirst.x[1]
    halfdt = dt / 2
    dtsq = dt^2
    eighth_dtsq = dtsq / 8
    half_dtsq = dtsq / 2
    ttmp = t + halfdt

    ## y₁ = y₀ + hy'₀ + h²∑b̄ᵢk'ᵢ
    @.. broadcast = false ku = uprev + halfdt * duprev + eighth_dtsq * k₁

    f.f1(k₂, duprev, ku, p, ttmp)
    @.. broadcast = false ku = uprev + dt * duprev + half_dtsq * k₂

    f.f1(k₃, duprev, ku, p, t + dt)
    @.. broadcast = false u = uprev + (dtsq / 6) * (k₁ + 2 * k₂) + dt * duprev
    @.. broadcast = false du = duprev + (dt / 6) * (k₁ + k₃ + 4 * k₂)

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.stats.nf2 += 1
end

@muladd function perform_step!(integrator, cache::IRKN3ConstantCache, repeat_step = false)
    (; t, dt, k, tprev, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    duprev2, uprev2 = integrator.uprev2.x
    (; bconst1, bconst2, c1, a21, b1, b2, bbar1, bbar2, k₂) = cache
    k₁ = integrator.fsalfirst
    # if there's a discontinuity or the solver is in the first step
    if integrator.iter < 2 && !integrator.u_modified
        perform_step!(integrator, Nystrom4VelocityIndependentConstantCache())
        k = integrator.fsallast
        k1cache = ArrayPartition((k.x[1], f.f1(duprev, uprev, p, t + c1 * dt)))
        kdu = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[1])
        k₂.x[1] = f.f1(duprev, kdu, p, t + c1 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    else
        kdu = uprev2 + dt * (c1 * duprev2 + dt * a21 * k1cache.x[1])
        ku = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[2])

        k₂x1 = f.f1(duprev, ku, p, t + c1 * dt)
        du = duprev +
            dt * (b1 * k1cache.x[1] + bbar1 * k1cache.x[1] + b2 * (k₂x1 - k₂.x[1]))
        u = uprev + bconst1 * dt * duprev +
            dt * (bconst2 * duprev2 + dt * bbar2 * (k₂x1 - k₂.x[1]))

        integrator.fsallast = ArrayPartition(
            (
                f.f1(du, u, p, t + dt),
                f.f2(du, u, p, t + dt),
            )
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        integrator.stats.nf2 += 1
        copyto!(k₂.x[1], k₂.x[2])
        k1cache = ArrayPartition((k1cache.x[1], k.x[2]))
    end # end if
end

@muladd function perform_step!(integrator, cache::IRKN3Cache, repeat_step = false)
    (; t, dt, k, tprev, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    duprev2, uprev2 = integrator.uprev2.x
    uidx = eachindex(integrator.uprev.x[1])
    (; tmp, fsalfirst, k₂, k) = cache
    (; bconst1, bconst2, c1, a21, b1, b2, bbar1, bbar2) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    k1cache = cache.tmp2
    k₁ = fsalfirst
    # if there's a discontinuity or the solver is in the first step
    if integrator.iter < 2 && !integrator.u_modified
        perform_step!(integrator, integrator.cache.onestep_cache)
        copyto!(k1cache.x[1], k.x[1])
        f.f1(k1cache.x[2], duprev, uprev, p, t + c1 * dt)
        @.. broadcast = false kdu = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[2])
        f.f1(k₂.x[1], duprev, kdu, p, t + c1 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    else
        @.. broadcast = false kdu = uprev2 + dt * (c1 * duprev2 + dt * a21 * k1cache.x[1])
        @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[2])

        f.f1(k₂.x[2], duprev, ku, p, t + c1 * dt)
        @tight_loop_macros for i in uidx
            @inbounds u[i] = uprev[i] + bconst1 * dt * duprev[i] +
                dt *
                (bconst2 * duprev2[i] + dt * bbar2 * (k₂.x[2][i] - k₂.x[1][i]))
            @inbounds du[i] = duprev[i] +
                dt * (
                b1 * k1cache.x[1][i] + bbar1 * k1cache.x[2][i] +
                    b2 * (k₂.x[2][i] - k₂.x[1][i])
            )
        end
        f.f1(k.x[1], du, u, p, t + dt)
        f.f2(k.x[2], du, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        integrator.stats.nf2 += 1
        copyto!(k₂.x[1], k₂.x[2])
        copyto!(k1cache.x[2], k1cache.x[1])
        copyto!(k1cache.x[1], k.x[1])
    end # end if
end

@muladd function perform_step!(integrator, cache::IRKN4Cache, repeat_step = false)
    (; t, dt, k, tprev, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    duprev2, uprev2 = integrator.uprev2.x
    uidx = eachindex(integrator.uprev.x[1])
    (; tmp, tmp2, fsalfirst, k₂, k₃, k) = cache
    (; bconst1, bconst2, c1, c2, a21, a32, b1, b2, b3, bbar1, bbar2, bbar3) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    k1cache = integrator.cache.tmp2
    k₁ = fsalfirst
    # if there's a discontinuity or the solver is in the first step
    if integrator.iter < 2 && !integrator.u_modified
        perform_step!(integrator, integrator.cache.onestep_cache)
        copyto!(k1cache.x[1], k.x[1])
        f.f1(k1cache.x[2], duprev, uprev, p, t + c1 * dt)
        @.. broadcast = false kdu = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[1])
        f.f1(k₂.x[1], duprev, kdu, p, t + c1 * dt)
        @.. broadcast = false kdu = uprev + dt * (c2 * duprev + dt * a32 * k1cache.x[2])
        f.f1(k₃.x[1], duprev, kdu, p, t + c1 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    else
        @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1cache.x[1])
        @.. broadcast = false kdu = uprev2 + dt * (c1 * duprev2 + dt * a21 * k1cache.x[2])

        f.f1(k₂.x[2], duprev, ku, p, t + c1 * dt)
        @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * a32 * k₂.x[2])
        @.. broadcast = false kdu = uprev2 + dt * (c2 * duprev2 + dt * a32 * k₂.x[1])

        f.f1(k₃.x[2], duprev, ku, p, t + c2 * dt)
        @tight_loop_macros for i in uidx
            @inbounds u[i] = uprev[i] + dt * bconst1 * duprev[i] +
                dt * (
                bconst2 * duprev2[i] +
                    dt * (
                    bbar2 * (k₂.x[2][i] - k₂.x[1][i]) +
                        bbar3 * (k₃.x[2][i] - k₃.x[1][i])
                )
            )
            @inbounds du[i] = duprev[i] +
                dt * (
                b1 * k1cache.x[1][i] + bbar1 * k1cache.x[2][i] +
                    b2 * (k₂.x[2][i] - k₂.x[1][i]) +
                    b3 * (k₃.x[2][i] - k₃.x[1][i])
            )
        end
        f.f1(k.x[1], du, u, p, t + dt)
        f.f2(k.x[2], du, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
        integrator.stats.nf2 += 1
        copyto!(k₂.x[1], k₂.x[2])
        copyto!(k₃.x[1], k₃.x[2])
        copyto!(k1cache.x[2], k1cache.x[1])
        copyto!(k1cache.x[1], k.x[1])
    end # end if
end

@muladd function perform_step!(
        integrator, cache::Nystrom5VelocityIndependentConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, a21, a31, a32, a41, a42, a43, bbar1, bbar2, bbar3, b1, b2, b3, b4) = cache
    k₁ = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k₁)

    k₂ = f.f1(duprev, ku, p, t + c1 * dt)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k₁ + a32 * k₂))

    k₃ = f.f1(duprev, ku, p, t + c2 * dt)
    ku = uprev + dt * (duprev + dt * (a41 * k₁ + a42 * k₂ + a43 * k₃))

    k₄ = f.f1(duprev, ku, p, t + dt)
    u = uprev + dt * (duprev + dt * (bbar1 * k₁ + bbar2 * k₂ + bbar3 * k₃))
    du = duprev + dt * (b1 * k₁ + b2 * k₂ + b3 * k₃ + b4 * k₄)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(
        integrator, cache::Nystrom5VelocityIndependentCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    uidx = eachindex(integrator.uprev.x[1])
    (; tmp, fsalfirst, k₂, k₃, k₄, k) = cache
    (; c1, c2, a21, a31, a32, a41, a42, a43, bbar1, bbar2, bbar3, b1, b2, b3, b4) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    k₁ = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k₁)

    f.f1(k₂, du, ku, p, t + c1 * dt)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k₁ + a32 * k₂))

    f.f1(k₃, du, ku, p, t + c2 * dt)
    #@tight_loop_macros for i in uidx
    #  @inbounds ku[i] = uprev[i] + dt*(duprev[i] + dt*(a41*k₁[i] + a42*k₂[i] + a43*k₃[i]))
    #end
    @.. broadcast = false ku = uprev + dt * (duprev + dt * (a41 * k₁ + a42 * k₂ + a43 * k₃))

    f.f1(k₄, duprev, ku, p, t + dt)
    #@tight_loop_macros for i in uidx
    #  @inbounds u[i]  = uprev[i] + dt*(duprev[i] + dt*(bbar1*k₁[i] + bbar2*k₂[i] + bbar3*k₃[i]))
    #  @inbounds du[i] = duprev[i] + dt*(b1*k₁[i] + b2*k₂[i] + b3*k₃[i] + b4*k₄[i])
    #end
    @.. broadcast = false u = uprev +
        dt * (duprev + dt * (bbar1 * k₁ + bbar2 * k₂ + bbar3 * k₃))
    @.. broadcast = false du = duprev + dt * (b1 * k₁ + b2 * k₂ + b3 * k₃ + b4 * k₄)
    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    return nothing
end

@muladd function perform_step!(integrator, cache::DPRKN4ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4, bptilde1, bptilde2, bptilde3, bptilde4) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)

    u = uprev + dt * (duprev + dt * (b1 * k1 + b2 * k2 + b3 * k3))
    du = duprev + dt * (bp1 * k1 + bp2 * k2 + bp3 * k3 + bp4 * k4)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde2 * k2 + btilde3 * k3 + btilde4 * k4)
        duhat = dt * (bptilde1 * k1 + bptilde2 * k2 + bptilde3 * k3 + bptilde4 * k4)
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k, utilde) = cache
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4, bptilde1, bptilde2, bptilde3, bptilde4) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt * (b1 * k1[i] + b2 * k2[i] + b3 * k3[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (bp1 * k1[i] + bp2 * k2[i] + bp3 * k3[i] + bp4 * k4[i])
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde2 * k2[i] + btilde3 * k3[i] +
                    btilde4 * k4[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde2 * k2[i] + bptilde3 * k3[i] +
                    bptilde4 * k4[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN5ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a43, a51, a53, a54, a61, a63, a64, a65, b1, b3, b4, b5, bp1, bp3, bp4, bp5, bp6, btilde1, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a53 * k3 + a54 * k4))

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev +
        dt * (c5 * duprev + dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5))

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    u = uprev +
        dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5))
    du = duprev +
        dt * (bp1 * k1 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5)
        duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5 +
                bptilde6 * k6
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN5Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k, utilde) = cache
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a43, a51, a53, a54, a61, a63, a64, a65, b1, b3, b4, b5, bp1, bp3, bp4, bp5, bp6, btilde1, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c4 * duprev[i] +
                dt * (a51 * k1[i] + a53 * k3[i] + a54 * k4[i])
        )
    end

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c5 * duprev[i] +
                dt * (a61 * k1[i] + a63 * k3[i] + a64 * k4[i] + a65 * k5[i])
        )
    end

    f.f1(k6, duprev, ku, p, t + dt * c5)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt * (b1 * k1[i] + b3 * k3[i] + b4 * k4[i] + b5 * k5[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (
            bp1 * k1[i] + bp3 * k3[i] + bp4 * k4[i] + bp5 * k5[i] +
                bp6 * k6[i]
        )
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde3 * k3[i] + btilde4 * k4[i] +
                    btilde5 * k5[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde3 * k3[i] + bptilde4 * k4[i] +
                    bptilde5 * k5[i] + bptilde6 * k6[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

function initialize!(integrator, cache::DPRKN6ConstantCache)
    duprev, uprev = integrator.uprev.x
    integrator.kshortsize = 3
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    kdu = integrator.f.f1(duprev, uprev, integrator.p, integrator.t)
    ku = integrator.f.f2(duprev, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    integrator.fsalfirst = ArrayPartition((kdu, ku))
    integrator.fsallast = zero(integrator.fsalfirst)

    integrator.k[1] = integrator.fsalfirst
    @inbounds for i in 2:(integrator.kshortsize - 1)
        integrator.k[i] = zero(integrator.fsalfirst)
    end
    return integrator.k[integrator.kshortsize] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::DPRKN6ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a63, a64, a65, b1, b3, b4, b5, bp1, bp3, bp4, bp5, bp6, btilde1, btilde2, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev + dt * (c5 * duprev + dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5)) # no a62

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    u = uprev + dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5)) # b1 -- b5, no b2
    du = duprev + dt * (bp1 * k1 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6) # bp1 -- bp6, no bp2

    #=
    @tight_loop_macros for i in uidx
      @inbounds u[i]  = uprev[i] + dt*(duprev[i] + dt*(bhat1*k1.x[2][i] + bhat2*k2.x[2][i] + bhat3*k3.x[2][i]))
      @inbounds du[i] = duprev[i]+ dt*(bphat1*k1.x[2][i] + bphat3*k3.x[2][i] + bphat4*k4.x[2][i] + bphat5*k5.x[2][i] + bphat6*k6.x[2][i])
    end
    =#

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    integrator.k[1] = ArrayPartition(integrator.fsalfirst.x[1], k2)
    integrator.k[2] = ArrayPartition(k3, k4)
    integrator.k[3] = ArrayPartition(k5, k6)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq *
            (btilde1 * k1 + btilde2 * k2 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5)
        duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5 +
                bptilde6 * k6
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

function initialize!(integrator, cache::DPRKN6Cache)
    (; fsalfirst, k) = cache
    duprev, uprev = integrator.uprev.x
    integrator.kshortsize = 3
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = ArrayPartition(cache.fsalfirst.x[1], cache.k2)
    integrator.k[2] = ArrayPartition(cache.k3, cache.k4)
    integrator.k[3] = ArrayPartition(cache.k5, cache.k6)
    integrator.f.f1(integrator.fsalfirst.x[1], duprev, uprev, integrator.p, integrator.t)
    integrator.f.f2(integrator.fsalfirst.x[2], duprev, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return integrator.stats.nf2 += 1
end

@muladd function perform_step!(integrator, cache::DPRKN6Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k, utilde) = cache
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a63, a64, a65, b1, b3, b4, b5, bp1, bp3, bp4, bp5, bp6, btilde1, btilde2, btilde3, btilde4, btilde5, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @.. broadcast = false ku = uprev +
        dt *
        (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @.. broadcast = false ku = uprev +
        dt *
        (c5 * duprev + dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5)) # no a62

    f.f1(k6, duprev, ku, p, t + dt * c5)

    @.. broadcast = false u = uprev +
        dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5)) # b1 -- b5, no b2
    @.. broadcast = false du = duprev +
        dt * (bp1 * k1 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6) # bp1 -- bp6, no bp2

    #=
    @tight_loop_macros for i in uidx
      @inbounds u[i]  = uprev[i] + dt*(duprev[i] + dt*(bhat1*k1.x[2][i] + bhat2*k2.x[2][i] + bhat3*k3.x[2][i]))
      @inbounds du[i] = duprev[i]+ dt*(bphat1*k1.x[2][i] + bphat3*k3.x[2][i] + bphat4*k4.x[2][i] + bphat5*k5.x[2][i] + bphat6*k6.x[2][i])
    end
    =#

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @.. broadcast = false uhat = dtsq * (
            btilde1 * k1 + btilde2 * k2 + btilde3 * k3 +
                btilde4 * k4 + btilde5 * k5
        )
        @.. broadcast = false duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 +
                bptilde5 * k5 + bptilde6 * k6
        )
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(
        integrator, cache::DPRKN6FMConstantCache,
        repeat_step = false
    )
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, b1, b2, b3, b4, b5, bp1, bp2, bp3, bp4, bp5, bp6, btilde1, btilde2, btilde3, btilde4, btilde5, bptilde1, bptilde2, bptilde3, bptilde4, bptilde5) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev +
        dt * (c5 * duprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5))

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    u = uprev +
        dt * (duprev + dt * (b1 * k1 + b2 * k2 + b3 * k3 + b4 * k4 + b5 * k5))
    du = duprev +
        dt * (bp1 * k1 + bp2 * k2 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq *
            (btilde1 * k1 + btilde2 * k2 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5)
        duhat = dt * (
            bptilde1 * k1 + bptilde2 * k2 + bptilde3 * k3 + bptilde4 * k4 +
                bptilde5 * k5
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN6FMCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k, utilde) = cache
    (; c1, c2, c3, c4, c5, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, b1, b2, b3, b4, b5, bp1, bp2, bp3, bp4, bp5, bp6, btilde1, btilde2, btilde3, btilde4, btilde5, bptilde1, bptilde2, bptilde3, bptilde4, bptilde5) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c4 * duprev[i] +
                dt * (a51 * k1[i] + a52 * k2[i] + a53 * k3[i] + a54 * k4[i])
        )
    end

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c5 * duprev[i] +
                dt * (
                a61 * k1[i] + a62 * k2[i] + a63 * k3[i] + a64 * k4[i] +
                    a65 * k5[i]
            )
        )
    end

    f.f1(k6, duprev, ku, p, t + dt * c5)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt *
                (b1 * k1[i] + b2 * k2[i] + b3 * k3[i] + b4 * k4[i] + b5 * k5[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (
            bp1 * k1[i] + bp2 * k2[i] + bp3 * k3[i] + bp4 * k4[i] +
                bp5 * k5[i] + bp6 * k6[i]
        )
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde2 * k2[i] + btilde3 * k3[i] +
                    btilde4 * k4[i] + btilde5 * k5[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde2 * k2[i] + bptilde3 * k3[i] +
                    bptilde4 * k4[i] + bptilde5 * k5[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN8ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, c6, c7, c8, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, a71, a72, a73, a74, a75, a76, a81, a82, a83, a84, a85, a86, a87, a91, a93, a94, a95, a96, a97, b1, b3, b4, b5, b6, b7, bp1, bp3, bp4, bp5, bp6, bp7, bp8, btilde1, btilde3, btilde4, btilde5, btilde6, btilde7, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7, bptilde8, bptilde9) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev +
        dt * (c5 * duprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5))

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    ku = uprev +
        dt * (
        c6 * duprev +
            dt * (a71 * k1 + a72 * k2 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6)
    )

    k7 = f.f1(duprev, ku, p, t + dt * c6)
    ku = uprev +
        dt * (
        c7 * duprev +
            dt * (a81 * k1 + a82 * k2 + a83 * k3 + a84 * k4 + a85 * k5 + a86 * k6 + a87 * k7)
    )

    k8 = f.f1(duprev, ku, p, t + dt * c7)
    ku = uprev +
        dt * (
        c8 * duprev +
            dt * (a91 * k1 + a93 * k3 + a94 * k4 + a95 * k5 + a96 * k6 + a97 * k7)
    ) # no a92 & a98

    k9 = f.f1(duprev, ku, p, t + dt * c8)
    u = uprev +
        dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5 + b6 * k6 + b7 * k7)) # b1 -- b7, no b2
    du = duprev +
        dt * (bp1 * k1 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6 + bp7 * k7 + bp8 * k8) # bp1 -- bp8, no bp2

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 9)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq *
            (
            btilde1 * k1 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5 + btilde6 * k6 +
                btilde7 * k7
        )
        duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5 +
                bptilde6 * k6 + bptilde7 * k7 + bptilde8 * k8 + bptilde9 * k9
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN8Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k7, k8, k9, k, utilde) = cache
    (; c1, c2, c3, c4, c5, c6, c7, c8, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, a71, a72, a73, a74, a75, a76, a81, a82, a83, a84, a85, a86, a87, a91, a93, a94, a95, a96, a97, b1, b3, b4, b5, b6, b7, bp1, bp3, bp4, bp5, bp6, bp7, bp8, btilde1, btilde3, btilde4, btilde5, btilde6, btilde7, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7, bptilde8, bptilde9) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c4 * duprev[i] +
                dt * (a51 * k1[i] + a52 * k2[i] + a53 * k3[i] + a54 * k4[i])
        )
    end

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c5 * duprev[i] +
                dt * (
                a61 * k1[i] + a62 * k2[i] + a63 * k3[i] + a64 * k4[i] +
                    a65 * k5[i]
            )
        )
    end

    f.f1(k6, duprev, ku, p, t + dt * c5)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c6 * duprev[i] +
                dt * (
                a71 * k1[i] + a72 * k2[i] + a73 * k3[i] + a74 * k4[i] +
                    a75 * k5[i] + a76 * k6[i]
            )
        )
    end

    f.f1(k7, duprev, ku, p, t + dt * c6)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c7 * duprev[i] +
                dt * (
                a81 * k1[i] + a82 * k2[i] + a83 * k3[i] + a84 * k4[i] +
                    a85 * k5[i] + a86 * k6[i] + a87 * k7[i]
            )
        )
    end

    f.f1(k8, duprev, ku, p, t + dt * c7)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c8 * duprev[i] +
                dt * (
                a91 * k1[i] + a93 * k3[i] + a94 * k4[i] + a95 * k5[i] +
                    a96 * k6[i] + a97 * k7[i]
            )
        ) # no a92 & a98
    end

    f.f1(k9, duprev, ku, p, t + dt * c8)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt *
                (
                b1 * k1[i] + b3 * k3[i] + b4 * k4[i] + b5 * k5[i] + b6 * k6[i] +
                    b7 * k7[i]
            )
        ) # b1 -- b7, no b2
        @inbounds du[i] = duprev[i] +
            dt * (
            bp1 * k1[i] + bp3 * k3[i] + bp4 * k4[i] + bp5 * k5[i] +
                bp6 * k6[i] + bp7 * k7[i] + bp8 * k8[i]
        ) # bp1 -- bp8, no bp2
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 9)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde3 * k3[i] + btilde4 * k4[i] +
                    btilde5 * k5[i] + btilde6 * k6[i] + btilde7 * k7[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde3 * k3[i] + bptilde4 * k4[i] +
                    bptilde5 * k5[i] + bptilde6 * k6[i] + bptilde7 * k7[i] +
                    bptilde8 * k8[i] + bptilde9 * k9[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN12ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, a21, a31, a32, a41, a42, a43, a51, a53, a54, a61, a63, a64, a65, a71, a73, a74, a75, a76, a81, a84, a85, a86, a87, a91, a93, a94, a95, a96, a97, a98, a101, a103, a104, a105, a106, a107, a108, a109, a111, a113, a114, a115, a116, a117, a118, a119, a1110, a121, a123, a124, a125, a126, a127, a128, a129, a1210, a1211, a131, a133, a134, a135, a136, a137, a138, a139, a1310, a1311, a1312, a141, a143, a144, a145, a146, a147, a148, a149, a1410, a1411, a1412, a1413, a151, a153, a154, a155, a156, a157, a158, a159, a1510, a1511, a1512, a1513, a1514, a161, a163, a164, a165, a166, a167, a168, a169, a1610, a1611, a1612, a1613, a1614, a1615, a171, a173, a174, a175, a176, a177, a178, a179, a1710, a1711, a1712, a1713, a1714, a1715, b1, b7, b8, b9, b10, b11, b12, b13, b14, b15, bp1, bp7, bp8, bp9, bp10, bp11, bp12, bp13, bp14, bp15, bp16, bp17, btilde1, btilde7, btilde8, btilde9, btilde10, btilde11, btilde12, btilde13, btilde14, btilde15, bptilde1, bptilde7, bptilde8, bptilde9, bptilde10, bptilde11, bptilde12, bptilde13, bptilde14, bptilde15, bptilde16, bptilde17) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a53 * k3 + a54 * k4)) # no a52

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev + dt * (c5 * duprev + dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5)) # no a62

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    ku = uprev +
        dt * (c6 * duprev + dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6)) # no a72

    k7 = f.f1(duprev, ku, p, t + dt * c6)
    ku = uprev +
        dt * (c7 * duprev + dt * (a81 * k1 + a84 * k4 + a85 * k5 + a86 * k6 + a87 * k7)) # no a82, a83

    k8 = f.f1(duprev, ku, p, t + dt * c7)
    ku = uprev +
        dt * (
        c8 * duprev +
            dt * (a91 * k1 + a93 * k3 + a94 * k4 + a95 * k5 + a96 * k6 + a97 * k7 + a98 * k8)
    ) # no a92

    k9 = f.f1(duprev, ku, p, t + dt * c8)
    ku = uprev +
        dt * (
        c9 * duprev +
            dt * (
            a101 * k1 + a103 * k3 + a104 * k4 + a105 * k5 + a106 * k6 + a107 * k7 +
                a108 * k8 + a109 * k9
        )
    ) # no a102

    k10 = f.f1(duprev, ku, p, t + dt * c9)
    ku = uprev +
        dt * (
        c10 * duprev +
            dt * (
            a111 * k1 + a113 * k3 + a114 * k4 + a115 * k5 + a116 * k6 + a117 * k7 +
                a118 * k8 + a119 * k9 + a1110 * k10
        )
    ) # no a112

    k11 = f.f1(duprev, ku, p, t + dt * c10)
    ku = uprev +
        dt * (
        c11 * duprev +
            dt * (
            a121 * k1 + a123 * k3 + a124 * k4 + a125 * k5 + a126 * k6 + a127 * k7 +
                a128 * k8 + a129 * k9 + a1210 * k10 + a1211 * k11
        )
    ) # no a122

    k12 = f.f1(duprev, ku, p, t + dt * c11)
    ku = uprev +
        dt * (
        c12 * duprev +
            dt * (
            a131 * k1 + a133 * k3 + a134 * k4 + a135 * k5 + a136 * k6 + a137 * k7 +
                a138 * k8 + a139 * k9 + a1310 * k10 + a1311 * k11 + a1312 * k12
        )
    ) # no a132

    k13 = f.f1(duprev, ku, p, t + dt * c12)
    ku = uprev +
        dt * (
        c13 * duprev +
            dt * (
            a141 * k1 + a143 * k3 + a144 * k4 + a145 * k5 + a146 * k6 + a147 * k7 +
                a148 * k8 + a149 * k9 + a1410 * k10 + a1411 * k11 + a1412 * k12 + a1413 * k13
        )
    ) # no a142

    k14 = f.f1(duprev, ku, p, t + dt * c13)
    ku = uprev +
        dt * (
        c14 * duprev +
            dt * (
            a151 * k1 + a153 * k3 + a154 * k4 + a155 * k5 + a156 * k6 + a157 * k7 +
                a158 * k8 + a159 * k9 + a1510 * k10 + a1511 * k11 + a1512 * k12 + a1513 * k13 +
                a1514 * k14
        )
    ) # no a152

    k15 = f.f1(duprev, ku, p, t + dt * c14)
    ku = uprev +
        dt * (
        c15 * duprev +
            dt * (
            a161 * k1 + a163 * k3 + a164 * k4 + a165 * k5 + a166 * k6 + a167 * k7 +
                a168 * k8 + a169 * k9 + a1610 * k10 + a1611 * k11 + a1612 * k12 + a1613 * k13 +
                a1614 * k14 + a1615 * k15
        )
    ) # no a162

    k16 = f.f1(duprev, ku, p, t + dt * c15)
    ku = uprev +
        dt * (
        c16 * duprev +
            dt * (
            a171 * k1 + a173 * k3 + a174 * k4 + a175 * k5 + a176 * k6 + a177 * k7 +
                a178 * k8 + a179 * k9 + a1710 * k10 + a1711 * k11 + a1712 * k12 + a1713 * k13 +
                a1714 * k14 + a1715 * k15
        )
    ) # no a172, a1716

    k17 = f.f1(duprev, ku, p, t + dt * c16)
    u = uprev +
        dt * (
        duprev +
            dt * (
            b1 * k1 + b7 * k7 + b8 * k8 + b9 * k9 + b10 * k10 + b11 * k11 + b12 * k12 +
                b13 * k13 + b14 * k14 + b15 * k15
        )
    ) # b1 & b7 -- b15
    du = duprev +
        dt *
        (
        bp1 * k1 + bp7 * k7 + bp8 * k8 + bp9 * k9 + bp10 * k10 + bp11 * k11 + bp12 * k12 +
            bp13 * k13 + bp14 * k14 + bp15 * k15 + bp16 * k16 + bp17 * k17
    ) # bp1 & bp7 -- bp17

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 17)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq *
            (
            btilde1 * k1 + btilde7 * k7 + btilde8 * k8 + btilde9 * k9 + btilde10 * k10 +
                btilde11 * k11 + btilde12 * k12 + btilde13 * k13 + btilde14 * k14 +
                btilde15 * k15
        ) # btilde1 & btilde7 -- btilde15
        duhat = dt * (
            bptilde1 * k1 + bptilde7 * k7 + bptilde8 * k8 + bptilde9 * k9 +
                bptilde10 * k10 + bptilde11 * k11 + bptilde12 * k12 + bptilde13 * k13 +
                bptilde14 * k14 + bptilde15 * k15 + bptilde16 * k16 + bptilde17 * k17
        ) # bptilde1 & bptilde7 -- bptilde17
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::DPRKN12Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15, k16, k17, k, utilde) = cache
    (; c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, a21, a31, a32, a41, a42, a43, a51, a53, a54, a61, a63, a64, a65, a71, a73, a74, a75, a76, a81, a84, a85, a86, a87, a91, a93, a94, a95, a96, a97, a98, a101, a103, a104, a105, a106, a107, a108, a109, a111, a113, a114, a115, a116, a117, a118, a119, a1110, a121, a123, a124, a125, a126, a127, a128, a129, a1210, a1211, a131, a133, a134, a135, a136, a137, a138, a139, a1310, a1311, a1312, a141, a143, a144, a145, a146, a147, a148, a149, a1410, a1411, a1412, a1413, a151, a153, a154, a155, a156, a157, a158, a159, a1510, a1511, a1512, a1513, a1514, a161, a163, a164, a165, a166, a167, a168, a169, a1610, a1611, a1612, a1613, a1614, a1615, a171, a173, a174, a175, a176, a177, a178, a179, a1710, a1711, a1712, a1713, a1714, a1715, b1, b7, b8, b9, b10, b11, b12, b13, b14, b15, bp1, bp7, bp8, bp9, bp10, bp11, bp12, bp13, bp14, bp15, bp16, bp17, btilde1, btilde7, btilde8, btilde9, btilde10, btilde11, btilde12, btilde13, btilde14, btilde15, bptilde1, bptilde7, bptilde8, bptilde9, bptilde10, bptilde11, bptilde12, bptilde13, bptilde14, bptilde15, bptilde16, bptilde17) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt *
            (c4 * duprev[i] + dt * (a51 * k1[i] + a53 * k3[i] + a54 * k4[i])) # no a52
    end

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c5 * duprev[i] +
                dt * (a61 * k1[i] + a63 * k3[i] + a64 * k4[i] + a65 * k5[i])
        ) # no a62
    end

    f.f1(k6, duprev, ku, p, t + dt * c5)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c6 * duprev[i] +
                dt * (
                a71 * k1[i] + a73 * k3[i] + a74 * k4[i] + a75 * k5[i] +
                    a76 * k6[i]
            )
        ) # no a72
    end

    f.f1(k7, duprev, ku, p, t + dt * c6)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c7 * duprev[i] +
                dt * (
                a81 * k1[i] + a84 * k4[i] + a85 * k5[i] + a86 * k6[i] +
                    a87 * k7[i]
            )
        ) # no a82, a83
    end

    f.f1(k8, duprev, ku, p, t + dt * c7)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c8 * duprev[i] +
                dt * (
                a91 * k1[i] + a93 * k3[i] + a94 * k4[i] + a95 * k5[i] +
                    a96 * k6[i] + a97 * k7[i] + a98 * k8[i]
            )
        ) # no a92
    end

    f.f1(k9, duprev, ku, p, t + dt * c8)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c9 * duprev[i] +
                dt *
                (
                a101 * k1[i] + a103 * k3[i] + a104 * k4[i] + a105 * k5[i] +
                    a106 * k6[i] + a107 * k7[i] + a108 * k8[i] + a109 * k9[i]
            )
        ) # no a102
    end

    f.f1(k10, duprev, ku, p, t + dt * c9)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c10 * duprev[i] +
                dt *
                (
                a111 * k1[i] + a113 * k3[i] + a114 * k4[i] + a115 * k5[i] +
                    a116 * k6[i] + a117 * k7[i] + a118 * k8[i] + a119 * k9[i] +
                    a1110 * k10[i]
            )
        ) # no a112
    end

    f.f1(k11, duprev, ku, p, t + dt * c10)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c11 * duprev[i] +
                dt *
                (
                a121 * k1[i] + a123 * k3[i] + a124 * k4[i] + a125 * k5[i] +
                    a126 * k6[i] + a127 * k7[i] + a128 * k8[i] + a129 * k9[i] +
                    a1210 * k10[i] + a1211 * k11[i]
            )
        ) # no a122
    end

    f.f1(k12, duprev, ku, p, t + dt * c11)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c12 * duprev[i] +
                dt *
                (
                a131 * k1[i] + a133 * k3[i] + a134 * k4[i] + a135 * k5[i] +
                    a136 * k6[i] + a137 * k7[i] + a138 * k8[i] + a139 * k9[i] +
                    a1310 * k10[i] + a1311 * k11[i] + a1312 * k12[i]
            )
        ) # no a132
    end

    f.f1(k13, duprev, ku, p, t + dt * c12)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c13 * duprev[i] +
                dt *
                (
                a141 * k1[i] + a143 * k3[i] + a144 * k4[i] + a145 * k5[i] +
                    a146 * k6[i] + a147 * k7[i] + a148 * k8[i] + a149 * k9[i] +
                    a1410 * k10[i] + a1411 * k11[i] + a1412 * k12[i] +
                    a1413 * k13[i]
            )
        ) # no a142
    end

    f.f1(k14, duprev, ku, p, t + dt * c13)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c14 * duprev[i] +
                dt *
                (
                a151 * k1[i] + a153 * k3[i] + a154 * k4[i] + a155 * k5[i] +
                    a156 * k6[i] + a157 * k7[i] + a158 * k8[i] + a159 * k9[i] +
                    a1510 * k10[i] + a1511 * k11[i] + a1512 * k12[i] +
                    a1513 * k13[i] + a1514 * k14[i]
            )
        ) # no a152
    end

    f.f1(k15, duprev, ku, p, t + dt * c14)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c15 * duprev[i] +
                dt *
                (
                a161 * k1[i] + a163 * k3[i] + a164 * k4[i] + a165 * k5[i] +
                    a166 * k6[i] + a167 * k7[i] + a168 * k8[i] + a169 * k9[i] +
                    a1610 * k10[i] + a1611 * k11[i] + a1612 * k12[i] +
                    a1613 * k13[i] + a1614 * k14[i] + a1615 * k15[i]
            )
        ) # no a162
    end

    f.f1(k16, duprev, ku, p, t + dt * c15)
    @tight_loop_macros for i in uidx
        @inbounds ku[i] = uprev[i] +
            dt * (
            c16 * duprev[i] +
                dt *
                (
                a171 * k1[i] + a173 * k3[i] + a174 * k4[i] + a175 * k5[i] +
                    a176 * k6[i] + a177 * k7[i] + a178 * k8[i] + a179 * k9[i] +
                    a1710 * k10[i] + a1711 * k11[i] + a1712 * k12[i] +
                    a1713 * k13[i] + a1714 * k14[i] + a1715 * k15[i]
            )
        ) # no a172, a1716
    end

    f.f1(k17, duprev, ku, p, t + dt * c16)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt * (
                b1 * k1[i] + b7 * k7[i] + b8 * k8[i] + b9 * k9[i] +
                    b10 * k10[i] + b11 * k11[i] + b12 * k12[i] + b13 * k13[i] +
                    b14 * k14[i] + b15 * k15[i]
            )
        ) # b1 & b7 -- b15
        @inbounds du[i] = duprev[i] +
            dt * (
            bp1 * k1[i] + bp7 * k7[i] + bp8 * k8[i] + bp9 * k9[i] +
                bp10 * k10[i] + bp11 * k11[i] + bp12 * k12[i] + bp13 * k13[i] +
                bp14 * k14[i] + bp15 * k15[i] + bp16 * k16[i] + bp17 * k17[i]
        ) # bp1 & bp7 -- bp17
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 17)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde7 * k7[i] + btilde8 * k8[i] +
                    btilde9 * k9[i] + btilde10 * k10[i] + btilde11 * k11[i] +
                    btilde12 * k12[i] + btilde13 * k13[i] + btilde14 * k14[i] +
                    btilde15 * k15[i]
            ) # btilde1 & btilde7 -- btilde15
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde7 * k7[i] + bptilde8 * k8[i] +
                    bptilde9 * k9[i] + bptilde10 * k10[i] +
                    bptilde11 * k11[i] + bptilde12 * k12[i] +
                    bptilde13 * k13[i] + bptilde14 * k14[i] +
                    bptilde15 * k15[i] + bptilde16 * k16[i] +
                    bptilde17 * k17[i]
            ) # bptilde1 & bptilde7 -- bptilde17
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN4ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, b4, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4, bptilde1, bptilde2, bptilde3, bptilde4) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    u = uprev + dt * (duprev + dt * (b1 * k1 + b2 * k2 + b3 * k3 + b4 * k4))
    du = duprev + dt * (bp1 * k1 + bp2 * k2 + bp3 * k3 + bp4 * k4)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde2 * k2 + btilde3 * k3 + btilde4 * k4)
        duhat = dt * (bptilde1 * k1 + bptilde2 * k2 + bptilde3 * k3 + bptilde4 * k4)
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k, utilde) = cache
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, b4, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4, bptilde1, bptilde2, bptilde3, bptilde4) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt * (b1 * k1[i] + b2 * k2[i] + b3 * k3[i] + b4 * k4[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (bp1 * k1[i] + bp2 * k2[i] + bp3 * k3[i] + bp4 * k4[i])
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde2 * k2[i] + btilde3 * k3[i] +
                    btilde4 * k4[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde2 * k2[i] + bptilde3 * k3[i] +
                    bptilde4 * k4[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN5ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, b4, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    u = uprev + dt * (duprev + dt * (b1 * k1 + b2 * k2 + b3 * k3 + b4 * k4))
    du = duprev + dt * (bp1 * k1 + bp2 * k2 + bp3 * k3 + bp4 * k4)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq * (btilde1 * k1 + btilde2 * k2 + btilde3 * k3 + btilde4 * k4)
        atmp = calculate_residuals(
            uhat, integrator.uprev.x[2], integrator.u.x[2],
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN5Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k, utilde) = cache
    (; c1, c2, c3, a21, a31, a32, a41, a42, a43, b1, b2, b3, b4, bp1, bp2, bp3, bp4, btilde1, btilde2, btilde3, btilde4) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt * (b1 * k1[i] + b2 * k2[i] + b3 * k3[i] + b4 * k4[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (bp1 * k1[i] + bp2 * k2[i] + bp3 * k3[i] + bp4 * k4[i])
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde2 * k2[i] + btilde3 * k3[i] +
                    btilde4 * k4[i]
            )
        end
        calculate_residuals!(
            atmp.x[2], uhat, integrator.uprev.x[2], integrator.u.x[2],
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp.x[2], t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN7ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    (; c1, c2, c3, c4, c5, c6, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, a71, a73, a74, a75, a76, b1, b3, b4, b5, b6, bp1, bp3, bp4, bp5, bp6, bp7, btilde1, btilde3, btilde4, btilde5, btilde6, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7) = cache
    k1 = integrator.fsalfirst.x[1]

    ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    k2 = f.f1(duprev, ku, p, t + dt * c1)
    ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    k3 = f.f1(duprev, ku, p, t + dt * c2)
    ku = uprev + dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    k4 = f.f1(duprev, ku, p, t + dt * c3)
    ku = uprev + dt * (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    k5 = f.f1(duprev, ku, p, t + dt * c4)
    ku = uprev +
        dt * (c5 * duprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5))

    k6 = f.f1(duprev, ku, p, t + dt * c5)
    ku = uprev +
        dt * (c6 * duprev + dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6))

    k7 = f.f1(duprev, ku, p, t + dt * c6)
    u = uprev + dt * (duprev + dt * (b1 * k1 + b3 * k3 + b4 * k4 + b5 * k5 + b6 * k6))
    du = duprev + dt * (bp1 * k1 + bp3 * k3 + bp4 * k4 + bp5 * k5 + bp6 * k6 + bp7 * k7)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    if integrator.opts.adaptive
        dtsq = dt^2
        uhat = dtsq *
            (btilde1 * k1 + btilde3 * k3 + btilde4 * k4 + btilde5 * k5 + btilde6 * k6)
        duhat = dt * (
            bptilde1 * k1 + bptilde3 * k3 + bptilde4 * k4 + bptilde5 * k5 +
                bptilde6 * k6 + bptilde7 * k7
        )
        utilde = ArrayPartition((duhat, uhat))
        atmp = calculate_residuals(
            utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ERKN7Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    du, u = integrator.u.x
    duprev, uprev = integrator.uprev.x
    (; tmp, atmp, fsalfirst, k2, k3, k4, k5, k6, k7, k, utilde) = cache
    (; c1, c2, c3, c4, c5, c6, a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, a62, a63, a64, a65, a71, a73, a74, a75, a76, b1, b3, b4, b5, b6, bp1, bp3, bp4, bp5, bp6, bp7, btilde1, btilde3, btilde4, btilde5, btilde6, bptilde1, bptilde3, bptilde4, bptilde5, bptilde6, bptilde7) = cache.tab
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]
    uidx = eachindex(integrator.uprev.x[2])
    k1 = integrator.fsalfirst.x[1]

    @.. broadcast = false ku = uprev + dt * (c1 * duprev + dt * a21 * k1)

    f.f1(k2, duprev, ku, p, t + dt * c1)
    @.. broadcast = false ku = uprev + dt * (c2 * duprev + dt * (a31 * k1 + a32 * k2))

    f.f1(k3, duprev, ku, p, t + dt * c2)
    @.. broadcast = false ku = uprev +
        dt * (c3 * duprev + dt * (a41 * k1 + a42 * k2 + a43 * k3))

    f.f1(k4, duprev, ku, p, t + dt * c3)
    @.. broadcast = false ku = uprev +
        dt *
        (c4 * duprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4))

    f.f1(k5, duprev, ku, p, t + dt * c4)
    @.. broadcast = false ku = uprev +
        dt * (
        c5 * duprev +
            dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5)
    )

    f.f1(k6, duprev, ku, p, t + dt * c5)
    @.. broadcast = false ku = uprev +
        dt * (
        c6 * duprev +
            dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6)
    )

    f.f1(k7, duprev, ku, p, t + dt * c6)
    @tight_loop_macros for i in uidx
        @inbounds u[i] = uprev[i] +
            dt * (
            duprev[i] +
                dt *
                (b1 * k1[i] + b3 * k3[i] + b4 * k4[i] + b5 * k5[i] + b6 * k6[i])
        )
        @inbounds du[i] = duprev[i] +
            dt * (
            bp1 * k1[i] + bp3 * k3[i] + bp4 * k4[i] + bp5 * k5[i] +
                bp6 * k6[i] + bp7 * k7[i]
        )
    end

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 1
    if integrator.opts.adaptive
        duhat, uhat = utilde.x
        dtsq = dt^2
        @tight_loop_macros for i in uidx
            @inbounds uhat[i] = dtsq *
                (
                btilde1 * k1[i] + btilde3 * k3[i] + btilde4 * k4[i] +
                    btilde5 * k5[i] + btilde6 * k6[i]
            )
            @inbounds duhat[i] = dt *
                (
                bptilde1 * k1[i] + bptilde3 * k3[i] + bptilde4 * k4[i] +
                    bptilde5 * k5[i] + bptilde6 * k6[i] + bptilde7 * k7[i]
            )
        end
        calculate_residuals!(
            atmp, utilde, integrator.uprev, integrator.u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

function initialize!(integrator, cache::RKN4Cache)
    (; fsalfirst, k) = cache
    duprev, uprev = integrator.uprev.x
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f.f1(integrator.k[1].x[1], duprev, uprev, integrator.p, integrator.t)
    integrator.f.f2(integrator.k[1].x[2], duprev, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return integrator.stats.nf2 += 1
end

@muladd function perform_step!(integrator, cache::RKN4ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    u, du = integrator.u.x
    #define dt values
    halfdt = dt / 2
    dtsq = dt^2
    eightdtsq = dtsq / 8
    halfdtsq = dtsq / 2
    sixthdtsq = dtsq / 6
    sixthdt = dt / 6
    ttmp = t + halfdt

    #perform operations to find k values
    k₁ = integrator.fsalfirst.x[1]
    ku = uprev + halfdt * duprev + eightdtsq * k₁
    kdu = duprev + halfdt * k₁

    k₂ = f.f1(kdu, ku, p, ttmp)
    ku = uprev + dt * duprev + halfdtsq * k₂
    kdu = duprev + dt * k₂

    k₃ = f.f1(kdu, ku, p, t + dt)

    #perform final calculations to determine new y and y'.
    u = uprev + sixthdtsq * (1 * k₁ + 2 * k₂ + 0 * k₃) + dt * duprev
    du = duprev + sixthdt * (1 * k₁ + 4 * k₂ + 1 * k₃)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((f.f1(du, u, p, t + dt), f.f2(du, u, p, t + dt)))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.stats.nf2 += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::RKN4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    du, u = integrator.u.x
    (; tmp, fsalfirst, k₂, k₃, k) = cache
    kdu, ku = integrator.cache.tmp.x[1], integrator.cache.tmp.x[2]

    #define dt values
    halfdt = dt / 2
    dtsq = dt^2
    eightdtsq = dtsq / 8
    halfdtsq = dtsq / 2
    sixthdtsq = dtsq / 6
    sixthdt = dt / 6
    ttmp = t + halfdt

    #perform operations to find k values
    k₁ = integrator.fsalfirst.x[1]
    @.. broadcast = false ku = uprev + halfdt * duprev + eightdtsq * k₁
    @.. broadcast = false kdu = duprev + halfdt * k₁

    f.f1(k₂, kdu, ku, p, ttmp)
    @.. broadcast = false ku = uprev + dt * duprev + halfdtsq * k₂
    @.. broadcast = false kdu = duprev + dt * k₂

    f.f1(k₃, kdu, ku, p, t + dt)

    #perform final calculations to determine new y and y'.
    @.. broadcast = false u = uprev + sixthdtsq * (1 * k₁ + 2 * k₂ + 0 * k₃) + dt * duprev
    @.. broadcast = false du = duprev + sixthdt * (1 * k₁ + 4 * k₂ + 1 * k₃)

    f.f1(k.x[1], du, u, p, t + dt)
    f.f2(k.x[2], du, u, p, t + dt)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.stats.nf2 += 1
end
